﻿Arena = LibStub("AceAddon-3.0"):NewAddon("Arena", "AceEvent-3.0")
local Arena = Arena
local self = Arena
local scheduleframe = CreateFrame("Frame")
local lsm3 = LibStub("LibSharedMedia-3.0")
local spellcache = setmetatable({}, {__index=function(t,v) local a = {GetSpellInfo(v)} if GetSpellInfo(v) then t[v] = a end return a end})
local optionoptions={macrotype="select"}
local function GetSpellInfo(a)
	return unpack(spellcache[a])
end
local auracache, drs, enemytalents, enemyspells, cdoverrides = {}, {}, {}, {}, {}
local function debugprint(...)
	if Arena.debug then
		print(...)
	end
end
local cooldowns = {
	[42292] = 120,
	[642] = 300,
	[1044] = 25,
	[1953] = 15,
	[45438] = 230,
	[53271] = 60,
	[18499] = 30,
	[46924] = 90,
	[60970] = 45,
	[50334] = 180,
	[586] = 30,
	[47585] = 120,
	[1856] = 90,
	[31224] = 60,
	[11305] = 120,
	[48020] = 30,
	[7744] = 120,
	[20589] = 105,
}
local cooldownnames
local immune_buffs = {
	["STUN"]={
		[1044]={3,26},
		[45438]=true,
		[642]=true,
		[48792]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["INCAPACIPATE"]={
		[45438]=true,
		[18499]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["SILENCE"]={
		[45438]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[54748]=true,
		[31821]=19746,
		[46924]=true,
	},
	["CYCLONE"]={
		[45438]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["OPENER_STUN"]={
		[1044]={3,26},
		[45438]=true,
		[642]=true,
		[48792]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["ROOT"]={
		[1044]=true,
		[45438]=true,
		[642]=true,
		[53271]=true,
		[34692]=true,
		[19263]=true,
		[47585]=true,
		[46924]=true,
	},
	["DISORIENT"]={
		[45438]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["SCATTERSHOT"]={
		[45438]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["SLEEP"]={
		[45438]=true,
		[642]=true,
		[48707]=true,
		[49039]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["CHARGE"]={
		[1044]={3,26},
		[45438]=true,
		[642]=true,
		[48792]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["FEAR"]={
		[6346]=true,
		[45438]=true,
		[18499]=true,
		[642]=true,
		[49039]=true,
		[50334]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["POLYMORPH"]={
		[5487]=true,
		[1066]=true,
		[783]=true,
		[768]=true,
		[45438]=true,
		[642]=true,
		[9634]=true,
		[48707]=true,
		[24858]=true,
		[33891]="preserve",
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["CHARM"]={
		[45438]=true,
		[642]=true,
		[48707]=true,
		[49039]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["SAP"]={
		[45438]=true,
		[18499]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
	["BLIND"]={
		[45438]=true,
		[642]=true,
		[34692]=true,
		[19263]=true,
		[46924]=true,
	},
}
local CCs = {
	["PALADIN"]={
		[853]="STUN",
		[20066]="INCAPACIPATE",
		[53709]="SILENCE",
	},
	["DRUID"]={
		[33786]="CYCLONE",
		[22570]="STUN",
		[9005]="OPENER_STUN",
		--[16979]="CHARGE",
		[5211]="STUN",
		[339]="ROOT",
	},
	["DEATHKNIGHT"]={
		[47476]="SILENCE",
		[49203]="DISORIENT",
		[47481]="STUN",
	},
	["HUNTER"]={
		[1499]="DISORIENT",
		[19503]="SCATTERSHOT",
		[19577]="STUN",
		[19386]="DISORIENT",
	},
	["WARRIOR"]={
		[100]="CHARGE",
		[5246]="FEAR",
		[12809]="STUN",
		[46968]="STUN",
	},
	["MAGE"]={
		[28271]="POLYMORPH",
		[12598]="SILENCE",
		[44572]="STUN",
	},
	["PRIEST"]={
		[8122]="FEAR",
		[15487]="SILENCE",
	},
	["WARLOCK"]={
		[5782]="FEAR",
		[6358]="CHARM",
		[30283]="STUN",
		[19647]="SILENCE",
	},
	["SHAMAN"]={
		[51514]="POLYMORPH",
	},
	["ROGUE"]={
		[26884]="SILENCE",
		[1833]="OPENER_STUN",
		[8643]="STUN",
		[51724]="SAP",
		[2094]="BLIND",
	},
	["Tauren"]={
		[20549]="STUN",
	},
	["BloodElf"]={
		[28730]="SILENCE",
	},
}

local tree_names = {
	["MAGE"]={
		[1]="Arcane",
		[2]="Fire",
		[3]="Frost",
	},
	["WARRIOR"]={
		[1]="Arms",
		[2]="Fury",
		[3]="Protection",
	},
	["PALADIN"]={
		[1]="Holy",
		[2]="Protection",
		[3]="Retribution",
	},
	["HUNTER"]={
		[1]="Beast Mastery",
		[2]="Marksmanship",
		[3]="Survival",
	},
	["ROGUE"]={
		[1]="Assassination",
		[2]="Combat",
		[3]="Sublety",
	},
	["DRUID"]={
		[1]="Balance",
		[2]="Feral Combat",
		[3]="Restoration",
	},
	["PRIEST"]={
		[1]="Discipline",
		[2]="Holy",
		[3]="Shadow",
	},
	["WARLOCK"]={
		[1]="Affliction",
		[2]="Demonology",
		[3]="Destruction",
	},
	["SHAMAN"]={
		[1]="Elemental",
		[2]="Enhancement",
		[3]="Restoration",
	},
	["DEATHKNIGHT"]={
		[1]="Blood",
		[2]="Frost",
		[3]="Unholy",
	},
}

local buff_talents = {
	[49016]={tree=1, points=31,class="DEATHKNIGHT"},
	[49182]={tree=1, points=1,class="DEATHKNIGHT"},
	[49004]={tree=1, points=6,class="DEATHKNIGHT"},
	[53137]={tree=1, points=26,class="DEATHKNIGHT"},
	[55233]={tree=1, points=36,class="DEATHKNIGHT"},
	[49039]={tree=2, points=11,class="DEATHKNIGHT"},
	[50880]={tree=2, points=11,class="DEATHKNIGHT"},
	[51123]={tree=2, points=16,class="DEATHKNIGHT"},
	[49796]={tree=2, points=21,class="DEATHKNIGHT"},
	[49188]={tree=2, points=26,class="DEATHKNIGHT"},
	[55610]={tree=2, points=26,class="DEATHKNIGHT"},
	[51271]={tree=2, points=36,class="DEATHKNIGHT"},
	[49200]={tree=2, points=41,class="DEATHKNIGHT"},
	[66799]={tree=3, points=31,class="DEATHKNIGHT"},
	[49222]={tree=3, points=36,class="DEATHKNIGHT"},
	[16880]={tree=1, points=11,class="DRUID"},
	[24907]={tree=1, points=31,class="DRUID"},
	[48389]={tree=1, points=36,class="DRUID"},
	[48516]={tree=1, points=41,class="DRUID"},
	[61336]={tree=1, points=11,class="DRUID"},
	[16972]={tree=2, points=15,class="DRUID"},
	[17007]={tree=2, points=31,class="DRUID"},
	[50334]={tree=2, points=51, class="DRUID"},
	[48411]={tree=3, points=11,class="DRUID"},
	[17116]={tree=3, points=21,class="DRUID"},
	[33881]={tree=3, points=31,class="DRUID"},
	[48496]={tree=3, points=36,class="DRUID"},
	[65139]={tree=3, points=41,class="DRUID"},
	[53251]={tree=3, points=51,class="DRUID"},
	[19578]={tree=1, points=21,class="HUNTER"},
	[34455]={tree=1, points=31,class="HUNTER"},
	[53256]={tree=1, points=41,class="HUNTER"},
	[34692]={tree=1, points=41,class="HUNTER"},
	[56314]={tree=1, points=46,class="HUNTER"},
	[34948]={tree=2, points=11,class="HUNTER"},
	[19506]={tree=2, points=31,class="HUNTER"},
	[56342]={tree=3, points=16,class="HUNTER"},
	[34506]={tree=3, points=36,class="HUNTER"},
	[53302]={tree=3, points=41,class="HUNTER"},
	[54646]={tree=1, points=11,class="MAGE"},
	[31570]={tree=1, points=21,class="MAGE"},
	[12043]={tree=1, points=21,class="MAGE"},
	[31571]={tree=1, points=26,class="MAGE"},
	[31579]={tree=1, points=31,class="MAGE"},
	[12042]={tree=1, points=31,class="MAGE"},
	[44394]={tree=1, points=31,class="MAGE"},
	[44404]={tree=1, points=41,class="MAGE"},
	[54747]={tree=2, points=6,class="MAGE"},
	[11103]={tree=2, points=11,class="MAGE"},
	[31641]={tree=2, points=26,class="MAGE"},
	[11129]={tree=2, points=31,class="MAGE"},
	[64353]={tree=2, points=36,class="MAGE"},
	[44442]={tree=2, points=42,class="MAGE"},
	[44445]={tree=2, points=41,class="MAGE"},
	[12472]={tree=3, points=11,class="MAGE"},
	[43039]={tree=3, points=31,class="MAGE"},
	[44543]={tree=3, points=36,class="MAGE"},
	[57761]={tree=3, points=41,class="MAGE"},
	[31821]={tree=1, points=11,class="PALADIN"},
	[20216]={tree=1, points=21,class="PALADIN"},
	[31833]={tree=1, points=31,class="PALADIN"},
	[53551]={tree=1, points=36,class="PALADIN"},
	[31842]={tree=1, points=41,class="PALADIN"},
	[53671]={tree=1, points=41,class="PALADIN"},
	[53569]={tree=1, points=46,class="PALADIN"},
	[53563]={tree=1, points=51,class="PALADIN"},
	[64205]={tree=2, points=11,class="PALADIN"},
	[53527]={tree=2, points=16,class="PALADIN"},
	[20911]={tree=2, points=21,class="PALADIN"},
	[25899]={tree=2, points=21,class="PALADIN"},
	[20177]={tree=2, points=21,class="PALADIN"},
	[48952]={tree=2, points=31,class="PALADIN"},
	[20127]={tree=2, points=36,class="PALADIN"},
	[20375]={tree=3, points=11,class="PALADIN"},
	[20049]={tree=3, points=26,class="PALADIN"},
	[53486]={tree=3, points=31,class="PALADIN"},
	[53501]={tree=3, points=41,class="PALADIN"},
	[14751]={tree=1, points=11,class="PRIEST"},
	[10060]={tree=1, points=31,class="PRIEST"},
	[45234]={tree=1, points=31,class="PRIEST"},
	[57470]={tree=1, points=36,class="PRIEST"},
	[47509]={tree=1, points=41,class="PRIEST"},
	[33206]={tree=1, points=41,class="PRIEST"},
	[47516]={tree=1, points=41,class="PRIEST"},
	[52795]={tree=1, points=46,class="PRIEST"},
	[27811]={tree=2, points=11,class="PRIEST"},
	[14892]={tree=2, points=11,class="PRIEST"},
	[20711]={tree=2, points=21,class="PRIEST"},
	[33150]={tree=2, points=26,class="PRIEST"},
	[34753]={tree=2, points=31,class="PRIEST"},
	[33142]={tree=2, points=31,class="PRIEST"},
	[64127]={tree=2, points=36,class="PRIEST"},
	[63730]={tree=2, points=36,class="PRIEST"},
	[47788]={tree=2, points=51,class="PRIEST"},
	[15337]={tree=3, points=4,class="PRIEST"},
	[15257]={tree=3, points=16,class="PRIEST"},
	[15286]={tree=3, points=21,class="PRIEST"},
	[15473]={tree=3, points=31,class="PRIEST"},
	[47585]={tree=3, points=51,class="PRIEST"},
	[14144]={tree=1, points=1,class="ROGUE"},
	[14177]={tree=1, points=21,class="ROGUE"},
	[58426]={tree=1, points=31,class="ROGUE"},
	[51662]={tree=1, points=51,class="ROGUE"},
	[13877]={tree=2, points=21,class="ROGUE"},
	[13750]={tree=2, points=31,class="ROGUE"},
	[51690]={tree=2, points=51,class="ROGUE"},
	[14278]={tree=3, points=11,class="ROGUE"},
	[31221]={tree=3, points=26,class="ROGUE"},
	[31228]={tree=3, points=31,class="ROGUE"},
	[36554]={tree=3, points=41,class="ROGUE"},
	[51713]={tree=3, points=51,class="ROGUE"},
	[30160]={tree=1, points=6, class="SHAMAN"},
	[16166]={tree=1, points=31, class="SHAMAN"},
	[51466]={tree=1, points=36, class="SHAMAN"},
	[51474]={tree=1, points=41, class="SHAMAN"},
	[57722]={tree=1, points=41, class="SHAMAN"},
	[16256]={tree=2, points=16, class="SHAMAN"},
	[30802]={tree=2, points=26, class="SHAMAN"},
	[30823]={tree=2, points=41, class="SHAMAN"},
	[51528]={tree=2, points=46, class="SHAMAN"},
	[55198]={tree=3, points=11, class="SHAMAN"},
	[16176]={tree=3, points=11, class="SHAMAN"},
	[16188]={tree=3, points=21, class="SHAMAN"},
	[30881]={tree=3, points=31, class="SHAMAN"},
	[16190]={tree=3, points=31, class="SHAMAN"},
	[49284]={tree=3, points=41, class="SHAMAN"},
	[51562]={tree=3, points=46, class="SHAMAN"},
	[61301]={tree=3, points=51, class="SHAMAN"},
	[47195]={tree=1, points=31, class="WARLOCK"},
	[19028]={tree=2, points=11, class="WARLOCK"},
	[18708]={tree=2, points=11, class="WARLOCK"},
	[23785]={tree=2, points=26, class="WARLOCK"},
	[47245]={tree=2, points=26, class="WARLOCK"},
	[63156]={tree=2, points=36, class="WARLOCK"},
	[47236]={tree=2, points=46, class="WARLOCK"},
	[59672]={tree=2, points=51, class="WARLOCK"},
	[34935]={tree=3, points=21, class="WARLOCK"},
	[30299]={tree=3, points=26, class="WARLOCK"},
	[18096]={tree=3, points=31, class="WARLOCK"},
	[47258]={tree=3, points=41, class="WARLOCK"},
	[47220]={tree=3, points=41, class="WARLOCK"},
	[56636]={tree=1, points=16, class="WARRIOR"},
	[12328]={tree=1, points=21, class="WARRIOR"},
	[29834]={tree=1, points=31, class="WARRIOR"},
	[64976]={tree=1, points=36, class="WARRIOR"},
	[29723]={tree=1, points=41, class="WARRIOR"},
	[46924]={tree=1, points=51, class="WARRIOR"},
	[16487]={tree=2, points=11, class="WARRIOR"},
	[12292]={tree=2, points=21, class="WARRIOR"},
	[12319]={tree=2, points=26, class="WARRIOR"},
	[23881]={tree=2, points=31, class="WARRIOR"},
	[46913]={tree=2, points=41, class="WARRIOR"},
	[12975]={tree=3, points=11, class="WARRIOR"},
	[50720]={tree=3, points=31, class="WARRIOR"},
	[46945]={tree=3, points=36, class="WARRIOR"},
	[46951]={tree=3, points=46, class="WARRIOR"},
}

--[===[@debug@
function gbt() return buff_talents end
--@end-debug@]===]

local talents = {
	["PALADIN"]={
		[31821]={tree=1, points=11},
		[20216]={tree=1, points=21},
		[48825]={tree=1, points=31},
		[31842]={tree=1, points=41},
		[53563]={tree=1, points=51},
		[64205]={tree=2, points=11},
		[20911]={tree=2, points=21},
		[48952]={tree=2, points=31},
		[48827]={tree=2, points=41},
		[53595]={tree=2, points=51},
		[20375]={tree=3, points=11},
		[20066]={tree=3, points=31},
		[35395]={tree=3, points=41},
		[53385]={tree=3, points=51},
	},
	["MAGE"]={
		[54646]={tree=1, points=11},
		[12043]={tree=1, points=21},
		[12042]={tree=1, points=31},
		[31589]={tree=1, points=41},
		[44781]={tree=1, points=51},
		[42891]={tree=2, points=11},
		[42945]={tree=2, points=21},
		[11129]={tree=2, points=31},
		[42950]={tree=2, points=41},
		[55360]={tree=2, points=51},
		[12472]={tree=3, points=11},
		[11958]={tree=3, points=21},
		[43039]={tree=3, points=31},
		[31687]={tree=3, points=41},
		[44572]={tree=3, points=51},
	},
	["HUNTER"]={
		[19577]={tree=1, points=21},
		[19574]={tree=1, points=31},
		[49050]={tree=2, points=11},
		[23989]={tree=2, points=21},
		[19506]={tree=2, points=31},
		[34490]={tree=2, points=41},
		[53209]={tree=2, points=51},
		[19503]={tree=3, points=11},
		[48999]={tree=3, points=21},
		[49012]={tree=3, points=31},
		[63672]={tree=3, points=41},
		[60053]={tree=3, points=51},
	},
	["SHAMAN"]={
		[16166]={tree=1, points=31},
		[57722]={tree=1, points=41},
		[59159]={tree=1, points=51},
		[17364]={tree=2, points=31},
		[60103]={tree=2, points=36},
		[30823]={tree=2, points=41},
		[51533]={tree=2, points=51},
		[55198]={tree=3, points=11},
		[16188]={tree=3, points=21},
		[51886]={tree=3, points=31},
		[16190]={tree=3, points=31},
		[49284]={tree=3, points=41},
		[61301]={tree=3, points=51},
	},
	["WARRIOR"]={
		[12328]={tree=1, points=21},
		[47486]={tree=1, points=31},
		[46924]={tree=1, points=51},
		[12323]={tree=2, points=11},
		[12292]={tree=2, points=21},
		[23881]={tree=2, points=31},
		[29801]={tree=2, points=41},
		[12975]={tree=3, points=11},
		[12809]={tree=3, points=21},
		[50720]={tree=3, points=31},
		[47498]={tree=3, points=41},
		[46968]={tree=3, points=51},
	},
	["DRUID"]={
		[48468]={tree=1, points=21},
		[24858]={tree=1, points=31},
		[33831]={tree=1, points=41},
		[61384]={tree=1, points=41},
		[53201]={tree=1, points=51},
		[61336]={tree=2, points=11},
		[16979]={tree=2, points=21},
		[49376]={tree=2, points=21},
		[33917]={tree=2, points=41},
		[50334]={tree=2, points=51},
		[17116]={tree=3, points=21},
		[18562]={tree=3, points=31},
		[65139]={tree=3, points=41},
		[53251]={tree=3, points=51},
	},
	["DEATHKNIGHT"]={
		[48982]={tree=1, points=11},
		[49005]={tree=1, points=21},
		[49016]={tree=1, points=31},
		[55262]={tree=1, points=41},
		[49028]={tree=1, points=51},
		[49039]={tree=2, points=11},
		[49796]={tree=2, points=21},
		[49203]={tree=2, points=31},
		[55268]={tree=2, points=41},
		[51411]={tree=2, points=51},
		[51328]={tree=3, points=11},
		[49194]={tree=3, points=21},
		[51052]={tree=3, points=31},
		[49222]={tree=3, points=36},
		[55271]={tree=3, points=41},
		[49206]={tree=3, points=51},
	},
	["PRIEST"]={
		[14751]={tree=1, points=11},
		[10060]={tree=1, points=31},
		[33206]={tree=1, points=41},
		[53007]={tree=1, points=51},
		[48173]={tree=2, points=11},
		[20711]={tree=2, points=21},
		[48087]={tree=2, points=31},
		[48089]={tree=2, points=41},
		[47788]={tree=2, points=51},
		[48156]={tree=3, points=11},
		[15286]={tree=3, points=21},
		[15487]={tree=3, points=21},
		[15473]={tree=3, points=31},
		[48160]={tree=3, points=41},
		[47585]={tree=3, points=51},
	},
	["ROGUE"]={
		[14177]={tree=1, points=21},
		[58426]={tree=1, points=31},
		[48666]={tree=1, points=41},
		[51662]={tree=1, points=51},
		[14251]={tree=2, points=11},
		[13877]={tree=2, points=21},
		[13750]={tree=2, points=31},
		[51690]={tree=2, points=51},
		[14278]={tree=3, points=11},
		[28660]={tree=3, points=21},
		[14185]={tree=3, points=21},
		[14183]={tree=3, points=31},
		[36554]={tree=3, points=41},
		[51713]={tree=3, points=51},
	},
	["WARLOCK"]={
		[18223]={tree=1, points=21},
		[59092]={tree=1, points=31},
		[47843]={tree=1, points=41},
		[59164]={tree=1, points=51},
		[19028]={tree=2, points=11},
		[18708]={tree=2, points=11},
		[47193]={tree=2, points=31},
		[30146]={tree=2, points=41},
		[59672]={tree=2, points=51},
		[47827]={tree=3, points=11},
		[17962]={tree=3, points=31},
		[47847]={tree=3, points=41},
		[59172]={tree=3, points=51},
	},
}
local cc_breakers = {
	["ALL"]={
		[42292] = {["ALL"]=true}
	},
	["PALADIN"]={
		[642] = {["ALL"]=true},
		[1044] = {["ROOT"]=true, ["STUN"]={3,26}, ["OPENER_STUN"]={3,26}, ["CHARGE"]={3,26}},
	},
	["MAGE"]={
		[1953] = {["STUN"]=true, ["OPENER_STUN"]=true, ["CHARGE"]=true, ["ROOT"]=true},
		[45438] = {["ALL"]=true},
	},
	["HUNTER"]={
		[53271] = {["ROOT"]=true},
		[19574] = {["ALL"]={1,41}},
	},
	["SHAMAN"] = {
	},
	["WARRIOR"] = {
		[18499] = {["SAP"]=true, ["INCAPACIPATE"]=true, ["FEAR"]=true},
		[46924] = {["ROOT"]={1,51}},
		[60970] = {["ROOT"]={2,41}},
	},
	["DRUID"] = {
		[0] = {["ROOT"]=true, ["POLYMORPH"]=true},
		[50334] = {["FEAR"]={2,51}},
	},
	["DEATHKNIGHT"] = {
	},
	["PRIEST"] = {
		[586] = {["ROOT"]={3,36}},
		[47585] = {["ROOT"]={3,51}},
	},
	["ROGUE"] = {
		[1856] = {["ROOT"]=true},
		[31224] = {["ROOT"]=true},
		[11305] = {["ROOT"]={2,16}},
	},
	["WARLOCK"] = {
		[48020] = {["ROOT"]=true},
	},
	["Scourge"] = {
		[7744] = {["FEAR"]=true, ["CHARM"]=true, ["SLEEP"]=true},
	},
	["Gnome"] = {
		[20589] = {["ROOT"]=true}
	},
}

local shared_cds = {
	[7744] = {[42292]=45},
	[42292] = {[7744]=45,[59752]=120},
	[59752] = {[42292]=120},
}

local dr_categories = {
	[853]="STUN",
	[20066]="INCAPACIPATE",
	[53709]="SILENCE",
	[33786]="CYCLONE",
	[22570]="STUN",
	[9005]="OPENER_STUN",
	--[16979]="CHARGE",
	[5211]="STUN",
	[339]="ROOT",
	[47476]="SILENCE",
	[49203]="DISORIENT",
	[47481]="STUN",
	[1499]="DISORIENT",
	[19503]="SCATTERSHOT",
	[19577]="STUN",
	[19386]="SLEEP",
	[100]="CHARGE",
	[5246]="FEAR",
	[12809]="STUN",
	[46968]="STUN",
	[28271]="POLYMORPH",
	[12598]="SILENCE",
	[8122]="FEAR",
	[15487]="SILENCE",
	[5782]="FEAR",
	[6358]="CHARM",
	[30283]="STUN",
	[19647]="SILENCE",
	[51514]="POLYMORPH",
	[26884]="SILENCE",
	[1833]="OPENER_STUN",
	[8643]="STUN",
	[51724]="SAP",
	[2094]="BLIND",
	[20549]="STUN",
	[28730]="SILENCE",
	[44572]="STUN",
}
local reverse_cats = setmetatable({}, {__index=function(t,v) local a = {} for i,k in pairs(dr_categories) do if v == k then tinsert(a, i) end end t[v]=a return a end})
local talent_spells = {
	[12598]={1,12},
	[53709]={2,24},
}
local shared_drs={
	["FEAR"]={"CHARM","BLIND"},
	["CHARM"]={"FEAR","BLIND"},
	["BLIND"]={"FEAR","CHARM"},
	["DISORIENT"]={"SAP","POLYMORPH","SLEEP"},
	["SAP"]={"DISORIENT","POLYMORPH","SLEEP"},
	["POLYMORPH"]={"DISORIENT","SAP","SLEEP"},
	["SLEEP"]={"DISORIENT","SAP","POLYMORPH"},
}
local debuff_ids={
	[853]=853,
	[20066]=20066,
	[63529]=53709,
	[33786]=33786,
	[22570]=22570,
	[9005]=9005,
	--[45334]=16979,
	[5211]=5211,
	[339]=339,
	[47476]=47476,
	[49203]=49203,
	[47481]=47481,
	[14309]=1499,
	[1499]=1499,
	[19503]=19503,
	[19577]=19577,
	[19386]=19386,
	[7922]=100,
	[5246]=5246,
	[12809]=12809,
	[46968]=46968,
	[28271]=28271,
	[55021]=12598,
	[8122]=8122,
	[15487]=15487,
	[5782]=5782,
	[6358]=6358,
	[30283]=30283,
	[19647]=19647,
	[51514]=51514,
	[1330]=26884,
	[1833]=1833,
	[8643]=8643,
	[51724]=51724,
	[2094]=2094,
	[20549]=20549,
	[28730]=28730,
}

local reverse_debuffids = setmetatable({}, {__index=function(t,v) local a = {} for i,k in pairs(debuff_ids) do if k == v then tinsert(a, i) end end t[v] = a return a end})

scheduleframe.s = {}
scheduleframe:SetScript("OnUpdate", function(self)
	if #self.s < 1 then self:Hide() return end
	while self.s[1] and self.s[1].t <= GetTime() do
		if type(self.s[1].f) == "string" then
			Arena[self.s[1].f](Arena, unpack(self.s[1].a))
		else
			self.s[1].f(unpack(self.s[1].a))
		end
		tremove(self.s,1)
	end
end)
local function round(num, places)
	return tonumber(string.format("%."..(places or 0).."f",num))
end
local function SetFriendlyAttribute(info, value)
	local clicktype, argtype = info[#info-2], info[#info]
	clicktype = clicktype=="leftclick" and 1 or clicktype=="rightclick" and 2 or 3
	Arena.opt.attributes.friendly[argtype..clicktype] = value
	Arena:UpdateFriendlyAttributes()
end
local function GetFriendlyAttribute(info)
	local clicktype, argtype = info[#info-2], info[#info]
	clicktype = clicktype == "leftclick" and 1 or clicktype =="rightclick" and 2 or 3
	return Arena.opt.attributes.friendly[argtype..clicktype]
end
local function SetEnemyAttribute(info, value)
	local clicktype, argtype = info[#info-2], info[#info]
	clicktype = clicktype=="leftclick" and 1 or clicktype=="rightclick" and 2 or 3
	Arena.opt.attributes.enemy[argtype..clicktype] = value
	Arena:UpdateEnemyAttributes()
end
local function GetEnemyAttribute(info)
	local clicktype, argtype = info[#info-2], info[#info]
	clicktype = clicktype == "leftclick" and 1 or clicktype =="rightclick" and 2 or 3
	return Arena.opt.attributes.enemy[argtype..clicktype]
end
local options = {
	type="group",
	disabled=InCombatLockdown,
	args={
		looks={
			type="group",
			order=1,
			name="Look `n´ feel",
			desc="Configure how Arena looks",
			args={
				gryphon={
					type="toggle",
					name="Gryphon",
					desc="Show/hide the gryphon artwork",
					get=function() return Arena.opt.looks.gryphon end,
					set=function(info, value) for _, frame in pairs(Arena.frames) do frame.texture2[value and "Show" or "Hide"](frame.texture2) end Arena.opt.looks.gryphon = value end,
					order=1,
				},
				texturefont={
					type="group",
					name="LibSharedMedia settings",
					dialogInline=true,
					order=2,
					args={
						bar={
							type="select",
							name="Bar texture",
							desc="Change the health/mana bar's textures",
							get=function() return Arena.opt.looks.bar end,
							set=function(info, value) Arena.opt.looks.bar = value local a = lsm3:Fetch("statusbar", value) for _,frame in pairs(Arena.frames) do frame.health.tx:SetTexture(a) frame.power.tx:SetTexture(a) end end,
							order=2,
							values=AceGUIWidgetLSMlists.statusbar,
							dialogControl = "LSM30_Statusbar",
						},
						font={
							type="select",
							name="Font",
							desc="Change the font Arena uses",
							get=function() return Arena.opt.looks.font end,
							set=function(info, value) Arena.opt.looks.font = value local a = lsm3:Fetch("font", value) for _, frame in pairs(Arena.frames) do frame.health.t:SetFont(a, Arena.opt.looks.size, Arena:CreateFontargString(Arena.opt.looks.fontargs)) frame.power.t:SetFont(a, Arena.opt.looks.size, Arena:CreateFontargString(Arena.opt.looks.fontargs)) frame.toptext:SetFont(a, Arena.opt.looks.smallsize, Arena:CreateFontargString(Arena.opt.looks.smallfontargs)) if f.name then f.name:SetFont(a, Arena.opt.looks.namesize, Arena:CreateFontargString(Arena.opt.looks.namefontargs)) end end end,
							order=3,
							values=AceGUIWidgetLSMlists.font,
							dialogControl = "LSM30_Font",
						},
					},
				},
				fontinfo={
					type="group",
					name="Health/Mana bar texts",
					order=3,
					dialogInline=true,
					args={
						size={
							type="range",
							name="Font size",
							desc="Adjust the font size",
							get=function() return Arena.opt.looks.size end,
							set=function(info, value) Arena.opt.looks.size = value local a = lsm3:Fetch("font", Arena.opt.looks.font) for _, frame in pairs(Arena.frames) do frame.health.t:SetFont(a, value, Arena:CreateFontargString(Arena.opt.looks.fontargs)) frame.power.t:SetFont(a, value, Arena:CreateFontargString(Arena.opt.looks.fontargs)) end end,
							min=1,
							max=32,
							step=1,
							order=1,
						},
						fontargs={
							type="multiselect",
							name="Font options",
							desc="Adjust additional font options",
							get=function(info, key) return Arena.opt.looks.fontargs[key] end,
							set=function(info, key, value) Arena.opt.looks.fontargs[key] = value local a = lsm3:Fetch("font", Arena.opt.looks.font) for _, frame in pairs(Arena.frames) do frame.health.t:SetFont(a, Arena.opt.looks.size, Arena:CreateFontargString(Arena.opt.looks.fontargs)) frame.power.t:SetFont(a, Arena.opt.looks.size, Arena:CreateFontargString(Arena.opt.looks.fontargs)) end end,
							order=2,
							values={["OUTLINE"]="Outline", ["MONOCHROME"]="Monochrome", ["THICKOUTLINE"]="Thick outline"},
						},
					},
				},
				namefont={
					type="group",
					name="Name texts",
					order=4,
					dialogInline=true,
					args={
						size={
							type="range",
							name="Font size",
							desc="Adjust the font size",
							get=function() return Arena.opt.looks.namesize end,
							set=function(info, value) Arena.opt.looks.namesize = value local a = lsm3:Fetch("font", Arena.opt.looks.font) for i=1, 5 do Arena.frames["team"..i].name:SetFont(a, value, Arena:CreateFontargString(Arena.opt.looks.namefontargs)) end end,
							min=1,
							max=32,
							step=1,
							order=1,
						},
						fontargs={
							type="multiselect",
							name="Font options",
							desc="Adjust additional font options",
							get=function(info, key) return Arena.opt.looks.namefontargs[key] end,
							set=function(info, key, value) Arena.opt.looks.namefontargs[key] = value local a = lsm3:Fetch("font", Arena.opt.looks.font) for i=1, 5 do Arena.frames["team"..i].name:SetFont(a, Arena.opt.looks.namesize, Arena:CreateFontargString(Arena.opt.looks.namefontargs)) end end,
							order=2,
							values={["OUTLINE"]="Outline", ["MONOCHROME"]="Monochrome", ["THICKOUTLINE"]="Thick outline"},
						},
					},
				},
				smallfont={
					type="group",
					name="Small texts",
					order=5,
					dialogInline=true,
					args={
						size={
							type="range",
							name="Font size",
							desc="Adjust the font size",
							get=function() return Arena.opt.looks.smallsize end,
							set=function(info, value) Arena.opt.looks.smallsize = value local a = lsm3:Fetch("font", Arena.opt.looks.font) for _, frame in pairs(Arena.frames) do frame.toptext:SetFont(a, value, Arena:CreateFontargString(Arena.opt.looks.smallfontargs)) end end,
							min=1,
							max=32,
							step=1,
							order=1,
						},
						fontargs={
							type="multiselect",
							name="Font options",
							desc="Adjust additional font options",
							get=function(info, key) return Arena.opt.looks.smallfontargs[key] end,
							set=function(info, key, value) Arena.opt.looks.smallfontargs[key] = value local a = lsm3:Fetch("font", Arena.opt.looks.font) for _, frame in pairs(Arena.frames) do frame.toptext:SetFont(a, Arena.opt.looks.smallsize, Arena:CreateFontargString(Arena.opt.looks.smallfontargs)) end end,
							order=2,
							values={["OUTLINE"]="Outline", ["MONOCHROME"]="Monochrome", ["THICKOUTLINE"]="Thick outline"},
						},
					},
				},
				scale={
					type="group",
					name="Scale settings",
					order=6,
					dialogInline=true,
					args={
						enemy={
							type="range",
							name="Enemy frame scale",
							desc="Adjust the scale of the enemy frames",
							get=function() return Arena.opt.looks.enemyscale end,
							set=function(info, value) Arena.opt.looks.enemyscale = value for i=1, 5 do Arena.frames["arena"..i]:SetScale(value) end end,
							min=0,
							max=2,
							isPercent=true,
							order=1,
						},
						friendly={
							type="range",
							name="Friendly frame scale",
							desc="Adjust the scale of your team member's frames",
							get=function() return Arena.opt.looks.friendlyscale end,
							set=function(info, value) Arena.opt.looks.friendlyscale = value for i=1, 5 do Arean.frames["team"..i]:SetScale(value) end end,
							min=0,
							max=2,
							isPercent=true,
							order=2,
						},
					},
				},
			},
		},
		runaction={
			type="group",
			order=2,
			name="Click actions",
			args={
				friendly={
					type="group",
					name="Team frames",
					order=1,
					get=GetFriendlyAttribute,
					set=SetFriendlyAttribute,
					args={
						leftclick={
							type="group",
							name="Left click",
							order=1,
							args={
								type={
									type="select",
									name="",
									values={
										["spell"]="Cast a spell",
										["item"]="Use an item",
										["macro"]="Run a macro",
										["action"]="Use an action slot",
										["pet"]="Cast a pet action",
										["target"]="Target this unit",
										["focus"]="Focus this unit",
										["assist"]="Assist this unit",
										["stop"]="Stop a spell cast in progress",
										["click"]="Simulate a click on another button",
										["attribute"]="Set an attribute on another frame",
									},
									get=function() return Arena.opt.attributes.friendly.type1 end,
									set=function(info, value) Arena.opt.attributes.friendly.type1 = value Arena:UpdateFriendlyAttributes() end,
									style="dropdown",
									order=1,
								},
								spell={
									type="group",
									name="Spell settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1 == "spell") end,
									dialogInline=true,
									args={
										spell={
											type="input",
											name="Spell name",
											--get=function() return Arena.opt.attributes.friendly.spell1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.spell1 = value Arena:UpdateFriendlyAttributes() end,
											order=1,
										},
										checkselfcast={
											type="toggle",
											name="Respect self cast keys",
											--get=function() return Arena.opt.attributes.friendly.checkselfcast1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.checkselfcast1 = value Arena:UpdateFriendlyAttributes() end,
											order=2,
										},
									},
								},
								item={
									type="group",
									name="Item settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1 == "item") end,
									dialogInline=true,
									args={
										item={
											type="input",
											name="Item identifier",
											desc="Usage: <bag> <slot> or <numeric equip slot> or <item name>",
											--get=function() return Arena.opt.attributes.friendly.item1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.item1 = value Arena:UpdateFriendlyAttributes() end,
											order=1,
										},
										checkselfcast={
											type="toggle",
											name="Respect self cast keys",
											--get=function() return Arena.opt.attributes.friendly.checkselfcast1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.checkselfcast1 = value Arena:UpdateFriendlyAttributes() end,
											order=2,
										},
									},
								},
								macro={
									type="group",
									name="Macro settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1 == "macro") end,
									dialogInline=true,
									args={
										macrotype={
											type="select",
											order=1,
											name="Macro type",
											desc="Select the type of macro to run",
											--get=function() return Arena.opt.attributes.friendly.macrotype1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.macrotype1 = value Arena:UpdateFriendlyAttributes() end,
											values={["select"]="Select a macro", ["text"]="Enter a macro text to run"},
										},
										macro={
											type="input",
											order=2,
											name="Macro",
											desc="Usage: <macro id> or <macro name>",
											--get=function() return Arena.opt.attributes.friendly.macro1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.macro1 = value Arena:UpdateFriendlyAttributes() end,
											hidden=function() return not (Arena.opt.attributes.friendly.macrotype1 == "select") end,
										},
										macrotext={
											type="input",
											order=2,
											name="Macro text",
											desc="Usage: <macro text>",
											--get=function() return Arena.opt.attributes.friendly.macrotext1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.macrotext1 = value Arena:UpdateFriendlyAttributes() end,
											hidden=function() return not (Arena.opt.attributes.friendly.macrotype1 == "text") end,
											multiline=true,
										},
									},
								},
								action={
									type="group",
									name="Action settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1=="action") end,
									dialogInline=true,
									args={
										action={
											type="range",
											min=1,
											max=12,
											step=1,
											name="Action button slot",
											order=1,
										},
										actionpage={
											type="range",
											min=1,
											max=10,
											step=1,
											name="Action bar page",
											order=2,
										},
									},
								},
								pet={
									type="group",
									name="Pet settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1=="pet") end,
									dialogInline=true,
									args={
										action={
											type="range",
											min=1,
											max=12,
											step=1,
											name="Pet action slot",
											order=1,
										},
									},
								},
								click={
									type="group",
									name="Click settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1=="click") end,
									dialogInline=true,
									args={
										clickbutton={
											type="input",
											name="Button",
											desc="The button to click",
											order=1,
										},
									},
								},
								attribute={
									type="group",
									name="Attribute settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type1=="attribute") end,
									dialogInline=true,
									args={
										["attribute-frame"]={
											type="input",
											name="Button",
											desc="The button to set the attribute on",
											order=1,
											width="full",
										},
										["attribute-name"]={
											type="input",
											name="Attribute key",
											order=2,
										},
										["attribute-value"]={
											type="input",
											name="Attribute value",
											order=3,
										},
									},
								},
							},
						},
						rightclick={
							type="group",
							name="Right click",
							order=2,
							args={
								type={
									type="select",
									name="",
									values={
										["spell"]="Cast a spell",
										["item"]="Use an item",
										["macro"]="Run a macro",
										["action"]="Use an action slot",
										["pet"]="Cast a pet action",
										["target"]="Target this unit",
										["focus"]="Focus this unit",
										["assist"]="Assist this unit",
										["stop"]="Stop a spell cast in progress",
										["click"]="Simulate a click on another button",
										["attribute"]="Set an attribute on another frame",
									},
									get=function() return Arena.opt.attributes.friendly.type2 end,
									set=function(info, value) Arena.opt.attributes.friendly.type2 = value Arena:UpdateFriendlyAttributes() end,
									style="dropdown",
									order=1,
								},
								spell={
									type="group",
									name="Spell settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2 == "spell") end,
									dialogInline=true,
									args={
										spell={
											type="input",
											name="Spell name",
											--get=function() return Arena.opt.attributes.friendly.spell1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.spell1 = value Arena:UpdateFriendlyAttributes() end,
											order=1,
										},
										checkselfcast={
											type="toggle",
											name="Respect self cast keys",
											--get=function() return Arena.opt.attributes.friendly.checkselfcast1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.checkselfcast1 = value Arena:UpdateFriendlyAttributes() end,
											order=2,
										},
									},
								},
								item={
									type="group",
									name="Item settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2 == "item") end,
									dialogInline=true,
									args={
										item={
											type="input",
											name="Item identifier",
											desc="Usage: <bag> <slot> or <numeric equip slot> or <item name>",
											--get=function() return Arena.opt.attributes.friendly.item1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.item1 = value Arena:UpdateFriendlyAttributes() end,
											order=1,
										},
										checkselfcast={
											type="toggle",
											name="Respect self cast keys",
											--get=function() return Arena.opt.attributes.friendly.checkselfcast1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.checkselfcast1 = value Arena:UpdateFriendlyAttributes() end,
											order=2,
										},
									},
								},
								macro={
									type="group",
									name="Macro settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2 == "macro") end,
									dialogInline=true,
									args={
										macrotype={
											type="select",
											order=1,
											name="Macro type",
											desc="Select the type of macro to run",
											--get=function() return Arena.opt.attributes.friendly.macrotype2 end,
											--set=function(info, value) Arena.opt.attributes.friendly.macrotype2 = value Arena:UpdateFriendlyAttributes() end,
											values={["select"]="Select a macro", ["text"]="Enter a macro text to run"},
										},
										macro={
											type="input",
											order=2,
											name="Macro",
											desc="Usage: <macro id> or <macro name>",
											--get=function() return Arena.opt.attributes.friendly.macro1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.macro1 = value Arena:UpdateFriendlyAttributes() end,
											hidden=function() return not (Arena.opt.attributes.friendly.macrotype2 == "select") end,
										},
										macrotext={
											type="input",
											order=2,
											name="Macro text",
											desc="Usage: <macro text>",
											--get=function() return Arena.opt.attributes.friendly.macrotext1 end,
											--set=function(info, value) Arena.opt.attributes.friendly.macrotext1 = value Arena:UpdateFriendlyAttributes() end,
											hidden=function() return not (Arena.opt.attributes.friendly.macrotype2 == "text") end,
											multiline=true,
										},
									},
								},
								action={
									type="group",
									name="Action settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2=="action") end,
									dialogInline=true,
									args={
										action={
											type="range",
											min=1,
											max=12,
											step=1,
											name="Action button slot",
											order=1,
										},
										actionpage={
											type="range",
											min=1,
											max=10,
											step=1,
											name="Action bar page",
											order=2,
										},
									},
								},
								pet={
									type="group",
									name="Pet settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2=="pet") end,
									dialogInline=true,
									args={
										action={
											type="range",
											min=1,
											max=12,
											step=1,
											name="Pet action slot",
											order=1,
										},
									},
								},
								click={
									type="group",
									name="Click settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2=="click") end,
									dialogInline=true,
									args={
										clickbutton={
											type="input",
											name="Button",
											desc="The button to click",
											order=1,
										},
									},
								},
								attribute={
									type="group",
									name="Attribute settings",
									order=2,
									hidden=function() return not (Arena.opt.attributes.friendly.type2=="attribute") end,
									dialogInline=true,
									args={
										["attribute-frame"]={
											type="input",
											name="Button",
											desc="The button to set the attribute on",
											order=1,
											width="full",
										},
										["attribute-name"]={
											type="input",
											name="Attribute key",
											order=2,
										},
										["attribute-value"]={
											type="input",
											name="Attribute value",
											order=3,
										},
									},
								},
							},
						},
					},
				},
				enemy={
					type="group",
					name="Enemy frames",
					order=2,
					args={
					},
				},
			},
		},
	},
}
local defaults={profile={
	looks = {
		font = lsm3:GetDefault("font"),
		bar = lsm3:GetDefault("statusbar"),
		gryphon = true,
		namesize=14,
		namefontargs={["OUTLINE"]=true,["MONOCHROME"]=false,["THICKOUTLINE"]=false},
		smallsize=10,
		smallfontargs={["OUTLINE"]=true, ["MONOCHROME"]=false, ["THICKOUTLINE"]=false},
		size=16,
		fontargs={["OUTLINE"]=true, ["MONOCHROME"]=false, ["THICKOUTLINE"]=false},
		enemyscale=1,
		friendlyscale=1,
	},
	positioning = {
		enemy={},
		friendly={},
	},
	attributes={
		enemy={
			type2="focus",
		},
		friendly={
			type1="target",
			type2="assist",
			spell1="",
			checkselfcast1=false,
			spell2="",
			checkselfcast2=false,
			item1="",
			item2="",
			macrotype1="select",
			macrotype2="select",
			macro1="",
			macro2="",
			macrotext1="",
			macrotext2="",
			action1=1,
			action2=1,
			actionpage1=1,
			actionpage2=1,
			clickbutton1="",
			clickbutton2="",
			["attribute-frame1"]="",
			["attribute-frame2"]="",
			["attribute-name1"]="",
			["attribute-name2"]="",
			["attribute-value1"]="",
			["attribute-value2"]="",
		}
	}
}}
function Arena:ScheduleTimer(t, f, ...)
	t = t+GetTime()
	tinsert(scheduleframe.s, {t=t,f=f,a={...}})
	table.sort(scheduleframe.s, function(a,b) return a.t < b.t end)
	if not scheduleframe:IsShown() then scheduleframe:Show() end
end
function Arena:CreateFontargString(argtable)
	local a = {}
	for key,value in pairs(argtable) do
		if value then
			tinsert(a,key)
		end
	end
	return table.concat(a,",")
end
function Arena:OnProfileEnable()
	self.opt = self.db.profile
end
local hframes = {}
function Arena:ScheduleHide(f)
	tinsert(hframes, f)
	f:SetScript("OnUpdate", nil)
end

local frameupdate = function(self)
	local u = self.unit
	local h,p,mh,mp,cr,cg,cb,pbct,uh,up,upt,ue,uc, uht
	ue = UnitExists(u)
	if ue then
		h,p,mh,mp,cr,cg,cb = UnitHealth(u), UnitPower(u), UnitHealthMax(u), UnitPowerMax(u)
		_, uc = UnitClass(u)
		pbct = PowerBarColor[(select(2,UnitPowerType(u)))]
		cr,cg,cb = pbct.r,pbct.g,pbct.b
		if self.c.h ~= h then
			self.c.h = h
			uh = true
		end
		if self.c.mh ~= mh then
			self.c.mh = mh
			uh = true
		end
		if self.c.p ~= p then
			self.c.p = p
			up = true
		end
		if self.c.mp ~= mp then
			self.c.mp = mp
			up = true
		end
		if self.c.cr ~= cr then
			self.c.cr = cr
			upt = true
		end
		if self.c.cg ~= cg then
			self.c.cg = cg
			upt = true
		end
		if self.c.cb ~= cb then
			self.c.cb = cb
			upt = true
		end
		if self.c.uc ~= uc then
			self.c.uc = uc
			uht = true
		end
		if uh then
			local hf = self.health
			hf.t:SetText(h.."/"..mh.." ("..(mh == 0 and 0 or round(h/mh*100,0)).."%)")
			hf.tx:SetWidth(h == 0 and -1 or hf:GetWidth()*h/mh)
		end
		if up then
			local pf = self.power
			pf.t:SetText(p.."/"..mp.." ("..(mp == 0 and 0 or round(p/mp*100,0)).."%)")
			pf.tx:SetWidth(p == 0 and -1 or pf:GetWidth()*p/mp)
		end
		if uht then
			local a = RAID_CLASS_COLORS[uc]
			if uc then
				self.health.tx:SetVertexColor(a.r,a.g,a.b)
			end
			Arena:UpdateColoring(u)
		end
		if upt then
			self.power.tx:SetVertexColor(cr,cg,cb)
		end
	else
		self.c.h, self.c.mh, self.c.p, self.c.mp = -2,-2,-2,-2
		self.health.t:SetText("?/?")
		self.health.tx:SetWidth(-1)
		self.power.t:SetText("?/?")
		self.power.tx:SetWidth(-1)
	end
end
function Arena:PLAYER_REGEN_ENABLED()
	for i,k in ipairs(hframes) do
		k:Hide()
		k:SetScript("OnUpdate", frameupdate)
	end
	table.wipe(hframes)
end

local function framedown(self,button)
	if button == "RightButton" and (IsLeftShiftKeyDown() or IsRightShiftKeyDown()) and not InCombatLockdown() then
		self.moving = true
		self:StartMoving()
	end
end

function Arena:UpdateEnemyAttributes()
	local a = self.opt.attributes.enemy
	local mts={}
	local c = 1
	local b = a["macrotype"..c]
	while b do
		mts[c] = b
		c=c+1
		b=a["macrotype"..c]
	end
	for fid=1, 5 do
		local f = self.frames["arena"..fid]
		if not f then return end
		for key, value in pairs(a) do
			local d = tonumber(string.match(key, "%d"))
			if key == "macro"..d then
				if mts[d] == "select" then
					f:SetAttribute(key, value)
					f:SetAttribute("macrotext"..d, nil)
				end
			elseif key == "macrotext"..d then
				if mts[d] == "text" then
					f:SetAttribute(key, value)
					f:SetAttribute("macro"..d, nil)
				end
			else
				f:SetAttribute(key, value)
			end
		end
	end
end

function Arena:UpdateFriendlyAttributes()
	local a = self.opt.attributes.friendly
	local mts={}
	local c = 1
	local b = a["macrotype"..c]
	while b do
		mts[c] = b
		c=c+1
		b=a["macrotype"..c]
	end
	for fid=1, 5 do
		local f = self.frames["team"..fid]
		for key, value in pairs(a) do
			local d = tonumber(string.match(key, "%d"))
			if key == "macro"..d then
				if mts[d] == "select" then
					f:SetAttribute(key, value)
					f:SetAttribute("macrotext"..d, nil)
				end
			elseif key == "macrotext"..d then
				if mts[d] == "text" then
					f:SetAttribute(key, value)
					f:SetAttribute("macro"..d, nil)
				end
			else
				f:SetAttribute(key, value)
			end
		end
	end
end

function Arena:InitFrame(frame)
	local unit, key = frame.unit, frame.key
	if key:find("1") then
		frame:SetMovable(true)
		frame:SetScript("OnMouseDown", framedown)
	end
	frame.health = CreateFrame("Frame", nil, frame)
	frame.power = CreateFrame("Frame", nil, frame)
	--frame.health:SetPoint("TOPRIGHT", )
	frame.health.tx = frame.health:CreateTexture(nil, "BACKGROUND")
	frame.health.tx:SetPoint("TOPLEFT")
	frame.health.tx:SetPoint("BOTTOMLEFT")
	frame.health.tx:SetTexture(lsm3:Fetch("statusbar", self.opt.looks.bar))
	frame.health.t = frame.health:CreateFontString(nil, "ARTWORK")
	frame.health.t:SetAllPoints()
	frame.health.t:SetFont(lsm3:Fetch("font", self.opt.looks.font), self.opt.looks.size, self:CreateFontargString(self.opt.looks.fontargs))
	frame.health.t:SetTextColor(1,1,1)
	frame.power:SetPoint("TOPLEFT", frame.health, "BOTTOMLEFT")
	frame.power:SetPoint("TOPRIGHT", frame.health, "BOTTOMRIGHT")
	frame.power.tx = frame.power:CreateTexture(nil, "BACKGROUND")
	frame.power.tx:SetPoint("TOPLEFT")
	frame.power.tx:SetPoint("BOTTOMLEFT")
	frame.power.tx:SetTexture(lsm3:Fetch("statusbar", self.opt.looks.bar))
	frame.power.t = frame.power:CreateFontString(nil, "ARTWORK")
	frame.power.t:SetAllPoints()
	frame.power.t:SetFont(lsm3:Fetch("font", self.opt.looks.font), self.opt.looks.size, self:CreateFontargString(self.opt.looks.fontargs))
	frame.power.t:SetTextColor(1,1,1)
	frame.c = {}
	frame:SetScript("OnUpdate", frameupdate)
	frame.texture = frame:CreateTexture(nil, "BORDER")
	frame.texture:SetAllPoints()
	frame.tframe = CreateFrame("Frame", nil, frame)
	frame.tframe:SetFrameLevel(3)
	frame.texture2 = frame.tframe:CreateTexture(nil, "ARTWORK")
	frame.texture2:SetAllPoints(frame)
	if not self.opt.looks.gryphon then
		frame.texture2:Hide()
	end
	frame.toptext = frame:CreateFontString(nil, "OVERLAY")
	frame.toptext:SetFont(lsm3:Fetch("font", self.opt.looks.font), self.opt.looks.smallsize, self:CreateFontargString(self.opt.looks.smallfontargs))
	frame.toptext:SetTextColor(1,1,1)
	frame:Hide()
end

function Arena:UpdateFrameShowHide()
	if InCombatLockdown() then return end
	local isArena = IsActiveBattlefieldArena()
	local teamsize
	if isArena then
		for bg=1, MAX_BATTLEFIELD_QUEUES do
			local status, mapname, instanceid, bracketmin, bracketmax, size = GetBattlefieldStatus(bg)
			if status == "active" and size ~= 0 then
				teamsize = size
				break
			end
		end
	else
		teamsize = 0
	end
	for nf=1, teamsize do
		self.frames["arena"..nf]:Show()
		self.frames["arena"..nf].toptext:SetText("0/0/0")
		self.frames["team"..nf]:Show()
		auracache["arena"..nf] = {}
		drs["arena"..nf] = {}
		enemytalents["arena"..nf]={[1]=0,[2]=0,[3]=0,remain=71}
		enemyspells["arena"..nf] = {}
		cdoverrides["arena"..nf] = {}
		self:UpdateDisplays("arena"..nf)
		self:UpdateColoring("arena"..nf)
	end
	for nhf=teamsize+1, 5 do
		self.frames["arena"..nhf]:Hide()
		self.frames["team"..nhf]:Hide()
	end
end

--[[function Arena:PLAYER_ENTERING_WORLD()
	Arena:ScheduleTimer(0.5, "UpdateFrameShowHide")
	self:UpdateFrameShowHide()
end--]]

function Arena:HasCCApplied(unit, category)
	if not UnitExists(unit) then return end
	local debuffs = reverse_cats[category]
	for n, id in pairs(debuffs) do
		local debuffnames = reverse_debuffids[id]
		for c, name in pairs(debuffnames) do
			if UnitDebuff(unit, name) then
				return true
			end
		end
	end
end

function Arena:GetArenaUnitMatch(unit)
	if not unit then return end
	if unit:find("arena%d") then return unit end
	for i=1, 5 do
		if UnitExists("arena"..i) and UnitIsUnit("arena"..i, unit) then return "arena"..i end
	end
end

function Arena:IsImmuneToCC(unit, category)
	if not UnitExists(unit) then return end
	if drs[unit][category] == 3 then return true end
	for buffname, info in pairs(immune_buffs[category]) do
		local ti = type(info)
		local n,r,i,c,d,du,e,ca,iss = UnitBuff(unit, buffname, ti == "string" and info)
		if n then
			if ti == "table" then
				if self:IsPossibleTalent(self:GetArenaUnitMatch(ca), unpack(info)) then return true end
			elseif ti == "number" then
				if UnitBuff(unit, (GetSpellInfo(info))) then return true end
			else
				return true
			end
		end
	end
end

function Arena:GetLowestPossibleCooldown(spellid)
	return cooldowns[spellid]
end

function Arena:IsOverrideCooldown(unit,spellid)
	return cdoverrides[unit][spellid]
end

function Arena:IsOnCooldown(unit, spellid)
	return ((enemyspells[unit][spellid] or 0) + (self:IsOverrideCooldown(unit, spellid) or self:GetLowestPossibleCooldown(spellid) or 0)) > GetTime()
end

function Arena:IsPossibleTalent(unit, tree, numpoints)
	return (enemytalents[unit][tree]+enemytalents[unit].remain) >= numpoints
end

function Arena:CanBreakCC(unit, category)
	if not UnitExists(unit) then return end
	local _,c = UnitClass(unit)
	local _,r = UnitRace(unit)
	local breaks = {}
	for id,x in pairs(cc_breakers.ALL) do
		local d = x[category] or breaks.ALL
		if d == true then
			if not Arena:IsOnCooldown(unit, id) then
				return true
			end
		end
	end
	for id,x in pairs(cc_breakers[c]) do
		local d = x[category] or breaks.ALL
		if d == true then
			if not Arena:IsOnCooldown(unit, id) then
				return true
			end
		elseif d then
			if Arena:IsPossibleTalent(unit, unpack(d)) then
				if not Arena:IsOnCooldown(unit,id) then
					return true
				end
			end
		end
	end
	if cc_breakers[r] then
		for id,x in pairs(cc_breakers[r]) do
			local d = x[category] or breaks.ALL
			if d == true then
				if not Arena:IsOnCooldown(unit, id) then
					return true
				end
			end
		end
	end
end

function Arena:UpdateColoring(unit)
	if not unit:find("arena%d") then return end
	local f = self.frames[unit]
	local i = 1
	local k = f["spell"..i]
	while k:IsShown() do
		do
			local id = k.id
			if self:HasCCApplied(unit, dr_categories[id]) then
				f["btn"..i.."in"]:SetVertexColor(0,0,1)
				break
			end
			if self:IsImmuneToCC(unit, dr_categories[id]) then
				f["btn"..i.."in"]:SetVertexColor(1,0,0)
				break
			end
			if self:CanBreakCC(unit, dr_categories[id]) then
				f["btn"..i.."in"]:SetVertexColor(1,0.6,0)
				break
			end
			f["btn"..i.."in"]:SetVertexColor(0,1,0)
			i=i+1
			k=f["spell"..i]
		end
	end
end

function Arena:UpdateEnemyTalentText(unit,spell)
	local talents = enemytalents[unit]
	debugprint("Updated talents for unit "..unit.." to: "..talents[1].."/"..talents[2].."/"..talents[3]..". "..talents.remain.." remaining. (Reason: cast "..spell..")")
	local mtalents = {}
	if talents[1] == talents[2] and talents[2] == talents[3] then
		tinsert(mtalents, "None")
	else
		local mx = math.max(talents[1], talents[2], talents[3])
		for i=1, 3 do
			if talents[i] == mx then tinsert(mtalents, tree_names[(select(2, UnitClass(unit)))][i]) end
		end
	end
	self.frames[unit].toptext:SetText(table.concat(mtalents, "/").." - "..talents[1].."/"..talents[2].."/"..talents[3])
end

function Arena:CombatEvent(event, ...)
	local e, sg = select(2, ...)
	if not (e=="SPELL_CAST_SUCCESS" or e=="SPELL_CAST_START") then return end
	local u
	for i=1, 5 do
		if UnitExists("arena"..i) and (UnitGUID("arena"..i) == sg) then
			u="arena"..i
			break
		end
	end
	if not u then return end
	local sid, sn = select(9, ...)
	local lc, c = UnitClass(u)
	local tcsn = talents[c][sn]
	if tcsn then
		if enemytalents[u][tcsn.tree] < tcsn.points then
			enemytalents[u][tcsn.tree] = tcsn.points
			enemytalents[u].remain = (71-(enemytalents[u][1]+enemytalents[u][2]+enemytalents[u][3]))
			self:UpdateColoring(u)
			self:UpdateEnemyTalentText(u,sn)
		end
	end
	local cdt = enemyspells[u]
	if cdt and cooldowns[cooldownnames[sn]] then
		cdt[cooldownnames[sn]] = GetTime()
		cdoverrides[u][cooldownnames[sn]] = nil
		if shared_cds[cooldownnames[sn]] then
			for n, cooldown in pairs(shared_cds[cooldownnames[sn]]) do
				cdoverrides[u][n] = cooldown
				cdt[n] = GetTime()
			end
		end
		self:UpdateColoring(u)
	end
end

function Arena:ScanSpellIDs()
	local a={}
	for n,i in pairs(debuff_ids) do
		if type(n) == "number" then
			a[(GetSpellInfo(n))] = i
		end
	end
	debuff_ids = a
	for class, classtable in pairs(talents) do
		local t = {}
		for spellid, spelldata in pairs(classtable) do
			if type(spellid) == "number" then
				local s = GetSpellInfo(spellid)
				if s then
					t[(GetSpellInfo(spellid))] = spelldata
				else
					print(s)
				end
			end
		end
		talents[class] = t
	end
	
	cooldownnames = {}
	for spellid in pairs(cooldowns) do
		cooldownnames[(GetSpellInfo(spellid))] = spellid
	end
	for category, ids in pairs(immune_buffs) do
		local a = {}
		for id, mods in pairs(ids) do
			local s, sr = GetSpellInfo(id)
			if mods == "preserve" then
				a[s] = sr
			else
				a[s] = mods
			end
		end
		immune_buffs[category] = a
	end
	local nbufftalents = {}
	for id, data in pairs(buff_talents) do
		nbufftalents[(GetSpellInfo(id))] = data
	end
	buff_talents = nbufftalents
	self:UnregisterEvent("SPELLS_CHANGED")
end
Arena:RegisterEvent("SPELLS_CHANGED","ScanSpellIDs")

function Arena:UpdateNameDisplay(event, unit)
	local u = string.match(unit, "party(%d)")
	if unit == "player" then u = 0 end
	if not u then return end
	u = tonumber(u) + 1
	f = self.frames["team"..u]
	f.name:SetText((UnitName(unit)))
end
Arena:RegisterEvent("UNIT_NAME_UPDATE", "UpdateNameDisplay")

function Arena:UpdateDisplays(unit)
	local aura, dr = auracache[unit], drs[unit]
	local applicable_debuffs = {}
	for num in pairs(CCs[(select(2, UnitClass("player")))]) do
		if talent_spells[num] then
			local _,_,_,_,rank = GetTalentInfo(unpack(talent_spells[num]))
			if rank > 0 then
				tinsert(applicable_debuffs, {t="talent", id=num, tab=talent_spells[num][1], talent=talent_spells[num][2]})
			end
		elseif (GetSpellInfo((GetSpellInfo(num)))) then
			tinsert(applicable_debuffs, {t="spell",id=num})
		end
	end
	if CCs[(select(2, UnitRace("player")))] then
		for num in pairs(CCs[(select(2, UnitRace("player")))]) do
			tinsert(applicable_debuffs, {t="spell",id=num})
		end
	end
	for i,k in ipairs(applicable_debuffs) do
		local n,r,ic
		if k.t=="spell" then
			n,r,ic= GetSpellInfo(k.id)
		elseif k.t == "talent" then
			n,ic = GetTalentInfo(k.tab,k.talent)
		end
		local f = self.frames[unit]
		f["spell"..i]:Show()
		f["spell"..i]:SetTexture(ic)
		f["btn"..i.."in"]:Show()
		local d = dr[dr_categories[k.id]] or 0
		f["btn"..i.."in"]:SetTexture("Interface\\AddOns\\Arena\\button_in"..(d==2 and "_quarter.tga" or d==1 and "_half.tga" or ".tga"))
		f["btn"..i]:Show()
		f["spell"..i].id = k.id
	end
	for c=(#applicable_debuffs+1), 5 do
		local f = self.frames[unit]
		f["btn"..c]:Hide()
		f["btn"..c.."in"]:Hide()
		f["spell"..c]:Hide()
	end
end

function Arena:RemoveDR(unit, category, status)
	if drs[unit][category] ~= status then return end
	drs[unit][category] = 0
	Arena:UpdateDisplays(unit)
end

function Arena:UpdateAuras(event,unit)
	if not unit:find("arena%d") then return end
	local shouldupdate = false
	if not auracache[unit] then print(unit) end
	for buff, ison in pairs(auracache[unit]) do
		if not UnitDebuff(unit, buff) then
			auracache[unit][buff] = nil
			shouldupdate = true
		end
	end
	local i = 1
	local name = UnitDebuff(unit, i)
	while name do
		if debuff_ids[name] then
			if not auracache[unit][name] then
				auracache[unit][name] = true
				drs[unit][dr_categories[debuff_ids[name]]] = (drs[unit][dr_categories[debuff_ids[name]]] or 0) + 1
				self:ScheduleTimer(15, "RemoveDR", unit, dr_categories[debuff_ids[name]], drs[unit][dr_categories[debuff_ids[name]]])
				if shared_drs[dr_categories[debuff_ids[name]]] then
					for k,cat in ipairs(shared_drs[dr_categories[debuff_ids[name]]]) do
						drs[unit][cat] = (drs[unit][cat] or 0)+1
						self:ScheduleTimer(15, "RemoveDR", unit, cat, drs[unit][cat])
					end
				end
				shouldupdate = true
			end
		end
		i=i+1
		name = UnitDebuff(unit, i)
	end
	--if (select(2, UnitClass(unit))) ~= "MAGE" then
		local bc = 1
		local buffname, rank, icon, count, dispeltype, duration, expires, caster = UnitBuff(unit, bc)
		while buffname do
			local btb = buff_talents[buffname]
			if btb then
				local enemycaster = self:GetArenaUnitMatch(caster)
				if UnitExists(enemycaster) and (btb.class and ((select(2, UnitClass(enemycaster)))==btb.class) or true) and (enemytalents[enemycaster][btb.tree] < btb.points) then
					enemytalents[enemycaster][btb.tree] = btb.points
					enemytalents[enemycaster].remain = (71-(enemytalents[enemycaster][1]+enemytalents[enemycaster][2]+enemytalents[enemycaster][3]))
					self:UpdateEnemyTalentText(enemycaster, buffname)
				end
			end
			bc = bc + 1
			buffname, rank, icon, count, dispeltype, duration, expires, caster = UnitBuff(unit, bc)
		end
	--end
	if shouldupdate then
		Arena:UpdateDisplays(unit)
	end
	Arena:UpdateColoring(unit)
end

function Arena:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ArenaConfig", defaults)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("LibDualSpec-1.0"):EnhanceDatabase(self.db, "Arena")
	LibStub("LibDualSpec-1.0"):EnhanceOptions(options.args.profiles, self.db)
	options.args.profiles.order = -1
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileEnable")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileEnable")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileEnable")
	self.opt = self.db.profile
	Arena:RegisterEvent("UPDATE_BATTLEFIELD_STATUS","UpdateFrameShowHide")
	Arena:RegisterEvent("PLAYER_REGEN_ENABLED")
	Arena:RegisterEvent("UNIT_AURA", "UpdateAuras")
	Arena:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatEvent")
	self.frames = {}
	for i=1, 5 do
		local f = CreateFrame("Button", "ArenaEnemy"..i.."Button", UIParent, "SecureUnitButtonTemplate")
		SecureUnitButton_OnLoad(f,"arena"..i, function() end)
		self.frames["arena"..i] = f
		if i > 1 then
			f:SetPoint("TOP", self.frames["arena"..(i-1)], "BOTTOM", 0, -10)
		else
			f:SetPoint(self.opt.positioning.enemy.point or "CENTER", nil, self.opt.positioning.enemy.rpoint or "CENTER", self.opt.positioning.enemy.x or 0, self.opt.positioning.enemy.y or 100)
		end
		f:SetScript("OnMouseUp", function(self)
			if not self.moving then return end
			self.moving = false
			self:StopMovingOrSizing()
			Arena.opt.positioning.enemy.point, _, Arena.opt.positioning.enemy.rpoint, Arena.opt.positioning.enemy.x, Arena.opt.positioning.enemy.y = self:GetPoint()
		end)
		f:SetHeight(100)
		f:SetWidth(300)
		f:SetScale(self.opt.looks.enemyscale)
		f.unit = f:GetAttribute("unit")
		f.key = "arena"..i
		self:InitFrame(f)
		f.health.tx:SetVertexColor(1,0,0)
		f.texture:SetTexture("Interface\\AddOns\\Arena\\BG_enemy.tga")
		f.texture2:SetTexture("Interface\\AddOns\\Arena\\BG_enemy2.tga")
		f.power:SetPoint("BOTTOMLEFT", 90, 10)
		f.health:SetPoint("BOTTOM", f, "CENTER", 45, -20)
		f.health:SetPoint("TOPLEFT", 90, -30)
		for tx=5, 1, -1 do
			local btn = f:CreateTexture(nil, "OVERLAY")
			local btn_in = f:CreateTexture(nil, "ARTWORK")
			btn:SetWidth(14)
			btn:SetHeight(14)
			btn:SetTexture("Interface\\AddOns\\Arena\\button.tga")
			btn_in:SetAllPoints(btn)
			btn_in:SetTexture("Interface\\AddOns\\Arena\\button_in.tga")
			f["btn"..tx] = btn
			f["btn"..tx.."in"] = btn_in
			local spell = f:CreateTexture(nil, "OVERLAY")
			spell:SetWidth(18)
			spell:SetHeight(18)
			--spell:SetTexture("Interface\\Icons\\Spell_Magic_PolymorphPig")
			f["spell"..tx] = spell
			if tx == 5 then
				btn:SetPoint("TOPRIGHT", -7, -6)
			else
				btn:SetPoint("RIGHT", f["btn"..(tx+1)], "LEFT", -24, 0)
			end
			spell:SetPoint("RIGHT", btn, "LEFT", -3, 0)
			f.toptext:SetPoint("BOTTOMRIGHT", f, "TOPRIGHT")
		end
	end
	for i=1, 5 do
		local f = CreateFrame("Button", "ArenaMember"..i.."Button", UIParent, "SecureUnitButtonTemplate")
		SecureUnitButton_OnLoad(f, i > 1 and "party"..(i-1) or "player", function() end)
		self.frames["team"..i] = f
		if i > 1 then
			f:SetPoint("TOP", self.frames["team"..(i-1)], "BOTTOM", 0, -10)
		else
			f:SetPoint(self.opt.positioning.friendly.point or "CENTER", nil, self.opt.positioning.friendly.rpoint or "CENTER", self.opt.positioning.friendly.x or 100, self.opt.positioning.friendly.y or -100)
		end
		f:SetScript("OnMouseUp", function(self)
			if not self.moving then return end
			self.moving = false
			self:StopMovingOrSizing()
			Arena.opt.positioning.friendly.point, _, Arena.opt.positioning.friendly.rpoint, Arena.opt.positioning.friendly.x, Arena.opt.positioning.friendly.y = self:GetPoint()
		end)
		f:SetHeight(100)
		f:SetWidth(300)
		f:SetScale(self.opt.looks.friendlyscale)
		f.unit = f:GetAttribute("unit")
		f.key = "team"..i
		self:InitFrame(f)
		f.health.tx:SetVertexColor(0,1,0)
		f.texture:SetTexture("Interface\\AddOns\\Arena\\BG_friendly.tga")
		f.texture2:SetTexture("Interface\\AddOns\\Arena\\BG_friendly2.tga")
		f.power:SetPoint("BOTTOMLEFT", 2, 10)
		f.health:SetPoint("BOTTOM", f, "CENTER", -45, -15)
		f.health:SetPoint("TOPLEFT", 2, -30)
		f.name = f:CreateFontString(nil, "OVERLAY")
		f.name:SetTextColor(1,1,1)
		f.name:SetFont(lsm3:Fetch("font", self.opt.looks.font), self.opt.looks.namesize, self:CreateFontargString(self.opt.looks.namefontargs))
		f.name:SetPoint("TOPLEFT", 7, -4)
		f.name:SetHeight(20)
		f.name:SetWidth(200)
		f.toptext:SetPoint("BOTTOMLEFT", f, "TOPLEFT")
		if i== 1 then
			f.name:SetText((UnitName("player")))
		end
	end
	Arena:UpdateFriendlyAttributes()
	Arena:UpdateEnemyAttributes()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Arena", options)
end
SlashCmdList["ARENA"] = function(input)
	LibStub("AceConfigDialog-3.0"):Open("Arena")
end
SLASH_ARENA1 = "/arena"